%define section		free
%define tlversion	0.1
%define ormversion	0.16.4

Name:		jackrabbit
Version:	1.0
Release:	0.r321061.2jpp
Epoch:		0
Summary:	Apache Jackrabbit JCR Implementation
License:	Apache Software License 2.0
Url:		http://incubator.apache.org/jackrabbit
Group:		Development/Libraries/Application Frameworks
Vendor:		JPackage Project
Distribution:	JPackage
Source0:	jackrabbit-1.0-dev-r321061.tar.gz
# svn export -r 321061 http://svn.apache.org/repos/asf/incubator/jackrabbit/trunk
Source1:        pom-maven2jpp-depcat.xsl
Source2:        pom-maven2jpp-newdepmap.xsl
Source3:        pom-maven2jpp-mapdeps.xsl
Source4:        jackrabbit-1.0-jpp-depmap.xml
Patch0:         jackrabbit-1.0-maven_xml.patch
Patch1:         jackrabbit-1.0-SimpleNode.patch
Patch2:         jackrabbit-1.0-orm-persistence-project_xml.patch
Patch3:         jackrabbit-1.0-jcr-server-project_xml.patch
BuildRequires:	maven
BuildRequires:	junit
BuildRequires:  jpackage-utils >= 0:1.6
BuildRequires:	ant >= 0:1.6, ant-trax
BuildRequires:	javacc
BuildRequires:	saxon, saxon-scripts
BuildRequires:	jakarta-jmeter
BuildRequires:	cglib
BuildRequires:	asm
BuildRequires:	berkeleydb
BuildRequires:	jakarta-commons-beanutils
BuildRequires:	jakarta-commons-chain
BuildRequires:	jakarta-commons-cli
BuildRequires:	jakarta-commons-codec
BuildRequires:	jakarta-commons-collections
BuildRequires:	jakarta-commons-dbcp
BuildRequires:	jakarta-commons-digester
BuildRequires:	jakarta-commons-fileupload
BuildRequires:	jakarta-commons-httpclient
BuildRequires:	jakarta-commons-jexl
BuildRequires:	jakarta-commons-lang
BuildRequires:	jakarta-commons-logging
BuildRequires:	jakarta-commons-pool
BuildRequires:	jakarta-poi
BuildRequires:	jakarta-taglibs-standard
BuildRequires:	concurrent
BuildRequires:	db-ojb
BuildRequires:	derby
BuildRequires:	dom4j
BuildRequires:	easymock
BuildRequires:	ehcache
BuildRequires:	excalibur-avalon-logkit
BuildRequires:	geronimo-specs
BuildRequires:	hibernate
BuildRequires:	hsqldb
BuildRequires:	jcr-1.0-api
BuildRequires:	jdom
BuildRequires:	log4j
BuildRequires:	lucene
BuildRequires:	mysql-connector-java
BuildRequires:	odmg
BuildRequires:	pdfbox
BuildRequires:	servletapi4
BuildRequires:	spring11
BuildRequires:	textmining
BuildRequires:	xalan-j2
BuildRequires:	xerces-j2
BuildRequires:	xml-commons-apis
BuildRequires:	cqfs
BuildRequires:	cqfs-jackrabbit

Requires:	jakarta-jmeter
Requires:	excalibur-avalon-logkit
Requires:	cglib
Requires:	asm
Requires:	jakarta-commons-beanutils
Requires:	jakarta-commons-chain
Requires:	jakarta-commons-cli
Requires:	jakarta-commons-codec
Requires:	jakarta-commons-collections
Requires:	jakarta-commons-dbcp
Requires:	jakarta-commons-digester
Requires:	jakarta-commons-fileupload
Requires:	jakarta-commons-httpclient
Requires:	jakarta-commons-jexl
Requires:	jakarta-commons-lang
Requires:	jakarta-commons-logging
Requires:	jakarta-commons-pool
Requires:	concurrent
Requires:	db-ojb
Requires:	dom4j
Requires:	ehcache
Requires:	geronimo-specs
Requires:	hibernate
Requires:	jcr-1.0-api
Requires:	jdom
Requires:	jakarta-taglibs-standard
Requires:	log4j
Requires:	lucene
Requires:	odmg
Requires:	pdfbox
Requires:	jakarta-poi
Requires:	servletapi4
Requires:	spring11
Requires:	textmining
Requires:	xerces-j2
Requires:	xml-commons-apis
BuildArch:	noarch
BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot

%description
The Jackrabbit Project has been formed to develop an open source 
implementation of the Content Repository for Java Technology API 
(JCR), being specified within the Java Community Process as 
JSR-170. Day Software, the JSR-170 specification lead, 
has licensed an initial implementation of the JCR reference 
implementation for use as seed code for this project. JCR 
specifies an API for application developers (and application 
frameworks) to use for interaction with modern content 
repositories that provide content services such as searching, 
versioning, transactions, etc. 

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
%{summary}.

%prep
rm -rf $RPM_BUILD_ROOT
%setup -q -n %{name}-%{version}-dev
# remove all binary libs
#find . -name "*.jar" -exec rm -f {} \;
for j in $(find . -name "*.jar"); do
	mv $j $j.no
done

%patch0 -b .sav
%patch1 -b .sav
%patch2 -b .sav
%patch3 -b .sav

%build

export DEPCAT=$(pwd)/jackrabbit-1.0-depcat.new.xml
echo '<?xml version="1.0" standalone="yes"?>' > $DEPCAT
echo '<depset>' >> $DEPCAT
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    /usr/bin/saxon project.xml %{SOURCE1} >> $DEPCAT
    popd
done
echo >> $DEPCAT
echo '</depset>' >> $DEPCAT
/usr/bin/saxon $DEPCAT %{SOURCE2} > jackrabbit-1.0-depmap.new.xml
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    cp project.xml project.xml.orig
    /usr/bin/saxon -o project.xml project.xml.orig %{SOURCE3} map=%{SOURCE4}
    popd
done

for p in $(find . -name project.properties); do
    echo >> $p
    echo maven.repo.remote=file:/usr/share/maven-1.0/repository >> $p
    echo maven.home.local=$(pwd)/.maven >> $p
done

mkdir -p .maven/repository/maven/jars
build-jar-repository .maven/repository/maven/jars maven-jelly-tags

mkdir -p .maven/repository/JPP/jars
build-jar-repository .maven/repository/JPP/jars \
javacc \
ant/ant-trax \
xalan-j2 \


build-jar-repository -s -p .maven/repository/JPP/jars \
jmeter/core \
jmeter/java \
excalibur/avalon-logkit \
cglib \
asm/asm \
commons-beanutils \
commons-chain \
commons-cli \
commons-codec \
commons-collections \
commons-dbcp \
commons-digester \
commons-fileupload \
commons-httpclient \
commons-jexl \
commons-lang \
commons-logging \
commons-pool \
concurrent \
db-ojb/db-ojb \
derby/derby \
dom4j \
easymock \
ehcache \
geronimo/spec-j2ee-connector-1.5 \
geronimo/spec-jta-1.0.1B \
hibernate \
hsqldb \
javacc \
jcr-1.0-api \
jdom \
berkeleydb \
jmeter/jorphan \
taglibs-core \
junit \
log4j \
lucene \
mysql-connector-java \
odmg \
pdfbox \
poi \
servletapi4 \
spring11 \
taglibs-standard \
textmining \
xerces-j2 \
xml-commons-apis \
cqfs \
cqfs-jackrabbit \


export MAVEN_HOME_LOCAL=$(pwd)/.maven

maven \
	-Dmaven.repo.remote=file:/usr/share/maven-1.0/repository \
	-Dmaven.home.local=$MAVEN_HOME_LOCAL \
	jackrabbit:generate-sql-parser \


maven \
	-Dmaven.repo.remote=file:/usr/share/maven-1.0/repository \
	-Dmaven.home.local=$MAVEN_HOME_LOCAL \
	jackrabbit:generate-xpath-parser \


maven \
	-Dmaven.repo.remote=file:/usr/share/maven-1.0/repository \
	-Dmaven.home.local=$MAVEN_HOME_LOCAL \
	jackrabbit:generate-fulltext-parser \


maven \
	-Dmaven.repo.remote=file:/usr/share/maven-1.0/repository \
	-Dmaven.home.local=$MAVEN_HOME_LOCAL \
	jar:install javadoc xdoc:transform

for cm in bdb-persistence db-persistence examples jca jcr-rmi jcr-commands jcr-ext jcr-server/webdav jcr-server/server jcr-server/client jcr-server/webapp jcrtaglib tck-webapp textfilters; do
	pushd contrib/$cm
	maven \
	-Dmaven.repo.remote=file:/usr/share/maven-1.0/repository \
	-Dmaven.home.local=$MAVEN_HOME_LOCAL \
	jar:install javadoc
	popd
done

pushd contrib/orm-persistence
maven \
	-Dmaven.repo.remote=file:/usr/share/maven-1.0/repository \
	-Dmaven.home.local=$MAVEN_HOME_LOCAL \
	start.test.server &

maven \
	-Dmaven.repo.remote=file:/usr/share/maven-1.0/repository \
	-Dmaven.home.local=$MAVEN_HOME_LOCAL \
	jar:install javadoc

cat > test.rc <<EOT
urlid test
url jdbc:hsqldb:hsql://localhost:9001
username sa
password
EOT

cat > shutdown.sql <<EOT
shutdown;
EOT

java -cp $(build-classpath hsqldb) org.hsqldb.util.SqlTool --rcfile test.rc test shutdown.sql

popd


%install
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -m 644 \
target/%{name}-%{version}-SNAPSHOT.jar \
$RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-%{version}.jar
install -m 644 \
modules/commons/target/%{name}-commons-%{version}-SNAPSHOT.jar \
$RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-commons-%{version}.jar
install -m 644 \
contrib/bdb-persistence/target/%{name}-bdb-%{version}-SNAPSHOT.jar \
$RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-bdb-%{version}.jar
install -m 644 \
contrib/db-persistence/target/%{name}-db-%{version}-SNAPSHOT.jar \
$RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-db-%{version}.jar
install -m 644 \
contrib/examples/target/%{name}-examples-%{version}-SNAPSHOT.jar \
$RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-examples-%{version}.jar
install -m 644 \
contrib/jca/target/%{name}-jca-%{version}-SNAPSHOT.jar \
$RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-jca-%{version}.jar
install -m 644 \
contrib/orm-persistence/target/%{name}-orm-%{ormversion}-dev.jar \
$RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-orm-%{ormversion}.jar
install -m 644 \
contrib/textfilters/target/%{name}-textfilters-%{version}-SNAPSHOT.jar \
$RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-textfilters-%{version}.jar

install -m 644 \
contrib/jcr-commands/target/jcr-commands-%{version}-SNAPSHOT.jar \
$RPM_BUILD_ROOT%{_javadir}/%{name}/jcr-commands-%{version}.jar
install -m 644 \
contrib/jcr-ext/target/jcr-ext-%{version}-SNAPSHOT.jar \
$RPM_BUILD_ROOT%{_javadir}/%{name}/jcr-ext-%{version}.jar
install -m 644 \
contrib/jcr-rmi/target/jcr-rmi-%{version}-SNAPSHOT.jar \
$RPM_BUILD_ROOT%{_javadir}/%{name}/jcr-rmi-%{version}.jar

install -m 644 \
contrib/jcr-server/client/target/jcr-client-%{version}-SNAPSHOT.jar \
$RPM_BUILD_ROOT%{_javadir}/%{name}/jcr-client-%{version}.jar
install -m 644 \
contrib/jcr-server/server/target/jcr-server-%{version}-SNAPSHOT.jar \
$RPM_BUILD_ROOT%{_javadir}/%{name}/jcr-server-%{version}.jar
install -m 644 \
contrib/jcr-server/webapp/target/jackrabbit-server-%{version}-SNAPSHOT.jar \
$RPM_BUILD_ROOT%{_javadir}/%{name}/jackrabbit-server-%{version}.jar
install -m 644 \
contrib/jcr-server/webdav/target/jcr-webdav-%{version}-SNAPSHOT.jar \
$RPM_BUILD_ROOT%{_javadir}/%{name}/jcr-webdav-%{version}.jar

install -m 644 \
contrib/tck-webapp/target/tck-webapp-%{version}.jar \
$RPM_BUILD_ROOT%{_javadir}/%{name}/tck-webapp-%{version}.jar

install -m 644 \
contrib/jcrtaglib/target/jcrtaglib-%{tlversion}.jar \
$RPM_BUILD_ROOT%{_javadir}/%{name}/jcrtaglib-%{tlversion}.jar



# create unversioned symlinks
(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{ormversion}*; do ln -sf ${jar} ${jar/-%{ormversion}/}; done)
(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{tlversion}*; do ln -sf ${jar} ${jar/-%{tlversion}/}; done)
(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} ${jar/-%{version}/}; done)

install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/docs/apidocs/* \
	$RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/bdb-persistence
cp -pr contrib/bdb-persistence/target/docs/apidocs/* \
	$RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/bdb-persistence
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/db-persistence
cp -pr contrib/db-persistence/target/docs/apidocs/* \
	$RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/db-persistence
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/examples
cp -pr contrib/examples/target/docs/apidocs/* \
	$RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/examples
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/jca
cp -pr contrib/jca/target/docs/apidocs/* \
	$RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/jca
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/jcr-commands
cp -pr contrib/jcr-commands/target/docs/apidocs/* \
	$RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/jcr-commands
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/jcr-ext
cp -pr contrib/jcr-ext/target/docs/apidocs/* \
	$RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/jcr-ext
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/jcr-rmi
cp -pr contrib/jcr-rmi/target/docs/apidocs/* \
	$RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/jcr-rmi

install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/jcr-server/client
cp -pr contrib/jcr-server/client/target/docs/apidocs/* \
	$RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/jcr-server/client
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/jcr-server/server
cp -pr contrib/jcr-server/server/target/docs/apidocs/* \
	$RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/jcr-server/server
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/jcr-server/webapp
cp -pr contrib/jcr-server/webapp/target/docs/apidocs/* \
	$RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/jcr-server/webapp
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/jcr-server/webdav
cp -pr contrib/jcr-server/webdav/target/docs/apidocs/* \
	$RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/jcr-server/webdav

install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/jcrtaglib
cp -pr contrib/jcrtaglib/target/docs/apidocs/* \
	$RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/jcrtaglib
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/orm-persistence
cp -pr contrib/orm-persistence/target/docs/apidocs/* \
	$RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/orm-persistence
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/tck-webapp
cp -pr contrib/tck-webapp/target/docs/apidocs/* \
	$RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/tck-webapp
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/textfilters
cp -pr contrib/textfilters/target/docs/apidocs/* \
	$RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/textfilters

ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink
rm -rf target/docs/apidocs

install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp LICENSE.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr target/docs/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}


%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi


%files 
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}/LICENSE.txt
%{_javadir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%ghost %{_javadocdir}/%{name}

%files manual
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}

%changelog
* Mon Oct 24 2005 Ralph Apel <r.apel at r-apel.de> 0:1.0-0.r321061.2jpp
- Downgrade Requirement to spring11

* Wed Oct 19 2005 Ralph Apel <r.apel at r-apel.de> 0:1.0-0.r321061.1jpp
- First build from this codebase
